{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Chapter 5: The Linked List"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 1, page no. 95"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 1\n",
      " \n",
      "\n",
      "How many nodes you want:\n",
      "3\n",
      "Enter the element: \n",
      "10\n",
      "Enter the element: \n",
      "15\n",
      "Enter the element: \n",
      "20\n",
      "\n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 5\n",
      " \n",
      "\n",
      "List is : \n",
      "10 15 20 \n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 6\n",
      " Number of elements are 3\n",
      "\n",
      "\n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 9\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, data=0, link=None):\n",
    "        self.data = data\n",
    "        self.link = link\n",
    "\n",
    "start = None\n",
    "\n",
    "def create_list(data):\n",
    "    global start\n",
    "    tmp = node(data)\n",
    "    q = node()\n",
    "    if(start==None):\n",
    "        start = tmp\n",
    "    else:\n",
    "        q = start\n",
    "    while(q.link != None):\n",
    "        q = q.link\n",
    "    q.link = tmp\n",
    "    \n",
    "def AddAtBeg(data):\n",
    "    global start\n",
    "    tmp = node(data)\n",
    "    if(start == None):\n",
    "        start = tmp\n",
    "    else:\n",
    "        tmp.link = start\n",
    "        start = tmp\n",
    "        \n",
    "def AddAfter(data, pos):\n",
    "    global start\n",
    "    q = start\n",
    "    for i in range(pos-1):\n",
    "        q = q.link\n",
    "        if(q == None):\n",
    "            print \"\\n\\n There are less than %d elements\" %pos\n",
    "            return\n",
    "    tmp = node(data)\n",
    "    tmp.link = q.link\n",
    "    q.link = tmp\n",
    "    \n",
    "def Del(data):\n",
    "    global start\n",
    "    if (start.data == data):\n",
    "        tmp = start\n",
    "        start = start.link\n",
    "        return\n",
    "    q = start\n",
    "    while(q.link.link != None):\n",
    "        if(q.link.data == data):\n",
    "            tmp = q.link\n",
    "            q.link = tmp.link\n",
    "            return\n",
    "        q = q.link\n",
    "    if(q.link.data == data):\n",
    "        tmp = q.link;\n",
    "        q.link = None\n",
    "        return\n",
    "    print \"\\n\\nElement %d not found\" %data\n",
    "\n",
    "def Display():\n",
    "    global start\n",
    "    if(start == None):\n",
    "        print \"\\n\\nList is empty\"\n",
    "        return\n",
    "    q=start\n",
    "    print \"\\n\\nList is : \"\n",
    "    while(q != None):\n",
    "        print q.data,\n",
    "        q = q.link\n",
    "\n",
    "def Count():\n",
    "    global start\n",
    "    q = start\n",
    "    cnt = 0\n",
    "    while(q != None):\n",
    "        q = q.link\n",
    "        cnt+=1\n",
    "    print \"Number of elements are %d\\n\" %cnt\n",
    "\n",
    "def Rev():\n",
    "    global start\n",
    "    if(start.link==None):\n",
    "        return\n",
    "    p1 = start\n",
    "    p2 = p1.link\n",
    "    p3 = p2.link\n",
    "    p1.link = None\n",
    "    p2.link = p1\n",
    "    while(p3 != None):\n",
    "        p1=p2\n",
    "        p2=p3\n",
    "        p3=p3.link\n",
    "        p2.link=p1\n",
    "    start=p2\n",
    "\n",
    "def Search(data):\n",
    "    global start\n",
    "    ptr = start\n",
    "    pos = 1\n",
    "    while(ptr!=None):\n",
    "        if (ptr.data == data):\n",
    "            print \"\\n\\nItem %d found at position %d\" %(data, pos)\n",
    "            return\n",
    "        ptr = ptr.link\n",
    "        pos+=1\n",
    "    if (ptr == None):\n",
    "        print \"\\n\\nItem %d not found in list\" %data\n",
    "\n",
    "while(1):\n",
    "    print \"\\n1.Create List\"\n",
    "    print \"2.Add at beginning\"\n",
    "    print \"3.Add after\"\n",
    "    print \"4.Delete\"\n",
    "    print \"5.Display\"\n",
    "    print \"6.Count\"\n",
    "    print \"7.Reverse\"\n",
    "    print \"8.Search\"\n",
    "    print \"9.Quit\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice =int(raw_input())\n",
    "    if choice == 1:\n",
    "        print \"\\n\\nHow many nodes you want:\"\n",
    "        n = int(raw_input())\n",
    "        for i in range(n):\n",
    "            print \"Enter the element: \"\n",
    "            data = int(raw_input())\n",
    "            create_list(data)\n",
    "    elif choice == 2:\n",
    "        print \"\\n\\nEnter the element : \"\n",
    "        data = int(raw_input())\n",
    "        AddAtBeg(data)\n",
    "    elif choice == 3:\n",
    "        print \"\\n\\nEnter the element : \"\n",
    "        data = int(raw_input())\n",
    "        print \"\\nEnter the position after which this element is inserted:\"\n",
    "        pos = int(raw_input())\n",
    "        AddAfter(data,pos)\n",
    "    elif choice == 4:\n",
    "        if (start == None):\n",
    "            print \"\\n\\nList is empty\"\n",
    "            continue\n",
    "        print \"\\n\\nEnter the element for deletion:\"\n",
    "        data = int(raw_input())\n",
    "        Del(data)\n",
    "    elif choice == 5:\n",
    "        Display()\n",
    "    elif choice == 6:\n",
    "        Count()\n",
    "    elif choice == 7:\n",
    "        Rev()\n",
    "    elif choice == 8:\n",
    "        print \"\\n\\nEnter the element to be searched:\"\n",
    "        data = int(raw_input())\n",
    "        Search(data)\n",
    "    elif choice == 9:\n",
    "        sys.exit()\n",
    "    else:\n",
    "        print \"\\n\\nWrong choice\""
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 2. page no. 101"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 1\n",
      " \n",
      "\n",
      "How many nodes you want:\n",
      "3\n",
      "Enter the element: \n",
      "5\n",
      "Enter the element: \n",
      "10\n",
      "Enter the element: \n",
      "15\n",
      "\n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 5\n",
      " \n",
      "\n",
      "List is : \n",
      "5 10 15 \n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 6\n",
      " Number of elements are 3\n",
      "\n",
      "\n",
      "1.Create List\n",
      "2.Add at beginning\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.Search\n",
      "9.Quit\n",
      "Enter your choice: 9\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "\n",
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, data=0, link=None):\n",
    "        self.data = data\n",
    "        self.link = link\n",
    "\n",
    "start = None\n",
    "\n",
    "class LinkedList():\n",
    "\n",
    "    def create_list(self,data):\n",
    "        global start\n",
    "        tmp = node(data)\n",
    "        q = node()\n",
    "        if(start==None):\n",
    "            start = tmp\n",
    "        else:\n",
    "            q = start\n",
    "        while(q.link != None):\n",
    "            q = q.link\n",
    "        q.link = tmp\n",
    "    \n",
    "    \n",
    "    def AddAtBeg(self,data):\n",
    "        global start\n",
    "        tmp = node(data)\n",
    "        if(start == None):\n",
    "            start = tmp\n",
    "        else:\n",
    "            tmp.link = start\n",
    "            start = tmp\n",
    "        \n",
    "\n",
    "    def AddAfter(self,data, pos):\n",
    "        global start\n",
    "        q = start\n",
    "        for i in range(pos-1):\n",
    "            q = q.link\n",
    "            if(q == None):\n",
    "                print \"\\n\\n There are less than %d elements\" %pos\n",
    "                return\n",
    "        tmp = node(data)\n",
    "        tmp.link = q.link\n",
    "        q.link = tmp\n",
    "    \n",
    "\n",
    "    def Del(self,data):\n",
    "        global start\n",
    "        if (start.data == data):\n",
    "            tmp = start\n",
    "            start = start.link\n",
    "            return\n",
    "        q = start\n",
    "        while(q.link.link != None):\n",
    "            if(q.link.data == data):\n",
    "                tmp = q.link\n",
    "                q.link = tmp.link\n",
    "                return\n",
    "            q = q.link\n",
    "        if(q.link.data == data):\n",
    "            tmp = q.link;\n",
    "            q.link = None\n",
    "            return\n",
    "        print \"\\n\\nElement %d not found\" %data    \n",
    "\n",
    "\n",
    "    def Display(self):\n",
    "        global start\n",
    "        if(start == None):\n",
    "            print \"\\n\\nList is empty\"\n",
    "            return\n",
    "        q=start\n",
    "        print \"\\n\\nList is : \"\n",
    "        while(q != None):\n",
    "            print q.data,\n",
    "            q = q.link\n",
    "    \n",
    "    def Count(self):\n",
    "        global start\n",
    "        q = start\n",
    "        cnt = 0\n",
    "        while(q != None):\n",
    "            q = q.link\n",
    "            cnt+=1\n",
    "        print \"Number of elements are %d\\n\" %cnt\n",
    "    \n",
    "    \n",
    "    def Rev(self):\n",
    "        global start\n",
    "        if(start.link==None):\n",
    "            return\n",
    "        p1 = start\n",
    "        p2 = p1.link\n",
    "        p3 = p2.link\n",
    "        p1.link = None\n",
    "        p2.link = p1\n",
    "        while(p3 != None):\n",
    "            p1=p2\n",
    "            p2=p3\n",
    "            p3=p3.link\n",
    "            p2.link=p1\n",
    "        start=p2\n",
    "    \n",
    "\n",
    "    def Search(self,data):\n",
    "        global start\n",
    "        ptr = start\n",
    "        pos = 1\n",
    "        while(ptr!=None):\n",
    "            if (ptr.data == data):\n",
    "                print \"\\n\\nItem %d found at position %d\" %(data, pos)\n",
    "                return\n",
    "            ptr = ptr.link\n",
    "            pos+=1\n",
    "        if (ptr == None):\n",
    "            print \"\\n\\nItem %d not found in list\" %data\n",
    "    \n",
    "\n",
    "l_list = LinkedList()\n",
    "\n",
    "while(1):\n",
    "    print \"\\n1.Create List\"\n",
    "    print \"2.Add at beginning\"\n",
    "    print \"3.Add after\"\n",
    "    print \"4.Delete\"\n",
    "    print \"5.Display\"\n",
    "    print \"6.Count\"\n",
    "    print \"7.Reverse\"\n",
    "    print \"8.Search\"\n",
    "    print \"9.Quit\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice =int(raw_input())\n",
    "    if choice == 1:\n",
    "        print \"\\n\\nHow many nodes you want:\"\n",
    "        n = int(raw_input())\n",
    "        for i in range(n):\n",
    "            print \"Enter the element: \"\n",
    "            data = int(raw_input())\n",
    "            l_list.create_list(data)\n",
    "    elif choice == 2:\n",
    "        print \"\\n\\nEnter the element : \"\n",
    "        data = int(raw_input())\n",
    "        l_list.AddAtBeg(data)\n",
    "    elif choice == 3:\n",
    "        print \"\\n\\nEnter the element : \"\n",
    "        data = int(raw_input())\n",
    "        print \"\\nEnter the position after which this element is inserted:\"\n",
    "        pos = int(raw_input())\n",
    "        l_list.AddAfter(data,pos)\n",
    "    elif choice == 4:\n",
    "        if (start == None):\n",
    "            print \"\\n\\nList is empty\"\n",
    "            continue\n",
    "        print \"\\n\\nEnter the element for deletion:\"\n",
    "        data = int(raw_input())\n",
    "        l_list.Del(data)\n",
    "    elif choice == 5:\n",
    "        l_list.Display()\n",
    "    elif choice == 6:\n",
    "        l_list.Count()\n",
    "    elif choice == 7:\n",
    "        l_list.Rev()\n",
    "    elif choice == 8:\n",
    "        print \"\\n\\nEnter the element to be searched:\"\n",
    "        data = int(raw_input())\n",
    "        l_list.Search(data)\n",
    "    elif choice == 9:\n",
    "        sys.exit()\n",
    "    else:\n",
    "        print \"\\n\\nWrong choice\""
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 3, page no. 109"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "\n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter element to be pushed: 5\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter element to be pushed: 10\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 3\n",
      " Stack elements: \n",
      "10 5 \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 4\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, link=None):\n",
    "        self.data = None\n",
    "        self.link = link\n",
    "        \n",
    "start = None\n",
    "\n",
    "\n",
    "def push(top):\n",
    "    new = node()\n",
    "    print \"Enter element to be pushed: \",\n",
    "    pushed_item = int(raw_input())\n",
    "    new.data = pushed_item\n",
    "    new.link = top\n",
    "    top = new\n",
    "    return top\n",
    "\n",
    "def pop(top):\n",
    "    tmp = node()\n",
    "    if(top == None):\n",
    "        print \"Stack is empty...\"  \n",
    "    else:\n",
    "        tmp = top\n",
    "        print \"Popped item is: \", tmp.data\n",
    "        top = top.link\n",
    "        tmp.link = None\n",
    "    return top\n",
    "\n",
    "def display(top):\n",
    "    if(top == None):\n",
    "        print \"Stack is empty...\"\n",
    "    else:\n",
    "        print \"Stack elements: \"\n",
    "        while(top.link != None):\n",
    "            print top.data,\n",
    "            top = top.link\n",
    "            \n",
    "Top = node()\n",
    "while(1):\n",
    "    print \"\\n1.PUSH\"\n",
    "    print \"2.POP\"\n",
    "    print \"3.DISPLAY\"\n",
    "    print \"4.EXIT\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        Top = push(Top)\n",
    "    elif choice == 2:\n",
    "        Top=pop(Top)\n",
    "    elif choice == 3:\n",
    "        display(Top)\n",
    "    elif choice == 4:\n",
    "        sys.exit()    \n",
    "    else:\n",
    "        print \"Wrong choice\"\n",
    "        print \"\\nDo you want to continue (Y/y) = \"\n",
    "        ch = raw_input()\n",
    "        if ch == 'Y' or ch == 'y':\n",
    "            continue\n",
    "        else:\n",
    "            sys.exit()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 4, page no. 111"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter element to be pushed: 5\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter element to be pushed: 10\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 3\n",
      " Stack elements: \n",
      "10 5 None \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.DISPLAY\n",
      "4.EXIT\n",
      "Enter your choice: 4\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, link=None):\n",
    "        self.data = None\n",
    "        self.link = link\n",
    "\n",
    "\n",
    "class linkList:\n",
    "    def push(self, top):\n",
    "        new = node()\n",
    "        print \"Enter element to be pushed: \",\n",
    "        pushed_item = int(raw_input())\n",
    "        new.data = pushed_item\n",
    "        new.link = top\n",
    "        top = new\n",
    "        return top\n",
    "\n",
    "    def pop(self, top):\n",
    "        tmp = node()\n",
    "        if(top == None):\n",
    "            print \"Stack is empty...\"  \n",
    "        else:\n",
    "            tmp = top\n",
    "            print \"Popped item is: \", tmp.data\n",
    "            top = top.link\n",
    "            tmp.link = None\n",
    "        return top\n",
    "\n",
    "    def display(self, top):\n",
    "        if(top == None):\n",
    "            print \"Stack is empty...\"\n",
    "        else:\n",
    "            print \"Stack elements: \"\n",
    "            while(top.link != None):\n",
    "                print top.data,\n",
    "                top = top.link\n",
    "            \n",
    "Top = node()\n",
    "link_list = linkList()\n",
    "while(1):\n",
    "    print \"\\n1.PUSH\"\n",
    "    print \"2.POP\"\n",
    "    print \"3.DISPLAY\"\n",
    "    print \"4.EXIT\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        Top = link_list.push(Top)\n",
    "    elif choice == 2:\n",
    "        Top = link_list.pop(Top)\n",
    "    elif choice == 3:\n",
    "        link_list.display(Top)\n",
    "    elif choice == 4:\n",
    "        sys.exit()    \n",
    "    else:\n",
    "        print \"Wrong choice\"\n",
    "        print \"\\nDo you want to continue (Y/y) = \"\n",
    "        ch = raw_input()\n",
    "        if ch == 'Y' or ch == 'y':\n",
    "            continue\n",
    "        else:\n",
    "            sys.exit()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 5, page no. 116"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter the no. to be pushed: 5\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter the no. to be pushed: 10\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 3\n",
      " The element(s) is/are: \n",
      "5 10 \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 4\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, link=None):\n",
    "        self.data = None\n",
    "        self.link = link\n",
    "\n",
    "def push(rear):\n",
    "    new_node = node()\n",
    "    print \"Enter the no. to be pushed: \",\n",
    "    new_node.data = int(raw_input())\n",
    "    new_node.link = None\n",
    "    if (rear != None):\n",
    "        rear.link = new_node\n",
    "    rear = new_node\n",
    "    return rear\n",
    "\n",
    "def pop(f, r):\n",
    "    if f == None:\n",
    "        print \"The Queue is empty\"\n",
    "    else:\n",
    "        print \"The poped element is: \", f.data\n",
    "        if f != r:\n",
    "            f = f.link\n",
    "        else:\n",
    "            f = None\n",
    "    return f\n",
    "\n",
    "def traverse(fr, re):\n",
    "    if fr == None:\n",
    "        print \"The Queue is empty\"\n",
    "    else:\n",
    "        print \"The element(s) is/are: \"\n",
    "        while fr != re:\n",
    "            print fr.data,\n",
    "            fr = fr.link\n",
    "        print fr.data,\n",
    "\n",
    "rear = None\n",
    "front = None\n",
    "while(1):\n",
    "    print \"\\n1.PUSH\"\n",
    "    print \"2.POP\"\n",
    "    print \"3.TRAVERSE\"\n",
    "    print \"4.EXIT\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        rear = push(rear)\n",
    "        if front == None:\n",
    "            front = rear\n",
    "    elif choice == 2:\n",
    "        front = pop(front, rear)\n",
    "        if front == None:\n",
    "            rear = None\n",
    "    elif choice == 3:\n",
    "        traverse(front, rear)\n",
    "    elif choice == 4:\n",
    "        sys.exit()    \n",
    "    else:\n",
    "        print \"Wrong choice\"\n",
    "        print \"\\nDo you want to continue (Y/y) = \"\n",
    "        ch = raw_input()\n",
    "        if ch == 'Y' or ch == 'y':\n",
    "            continue\n",
    "        else:\n",
    "            sys.exit()\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 6, page no. 119"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter the no. to be pushed: 5\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 1\n",
      " Enter the no. to be pushed: 10\n",
      " \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 3\n",
      " The element(s) is/are: \n",
      "5 10 \n",
      "1.PUSH\n",
      "2.POP\n",
      "3.TRAVERSE\n",
      "4.EXIT\n",
      "Enter your choice: 5\n",
      " Wrong choice\n",
      "\n",
      "Do you want to continue (Y/y) = \n",
      "n\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, link=None):\n",
    "        self.data = None\n",
    "        self.link = link\n",
    "\n",
    "class linkList:\n",
    "    def push(self, rear):\n",
    "        new_node = node()\n",
    "        print \"Enter the no. to be pushed: \",\n",
    "        new_node.data = int(raw_input())\n",
    "        new_node.link = None\n",
    "        if (rear != None):\n",
    "            rear.link = new_node\n",
    "        rear = new_node\n",
    "        return rear\n",
    "\n",
    "    def pop(self, f, r):\n",
    "        if f == None:\n",
    "            print \"The Queue is empty\"\n",
    "        else:\n",
    "            print \"The poped element is: \", f.data\n",
    "            if f != r:\n",
    "                f = f.link\n",
    "            else:\n",
    "                f = None\n",
    "        return f\n",
    "\n",
    "    def traverse(self, fr, re):\n",
    "        if fr == None:\n",
    "            print \"The Queue is empty\"\n",
    "        else:\n",
    "            print \"The element(s) is/are: \"\n",
    "            while fr != re:\n",
    "                print fr.data,\n",
    "                fr = fr.link\n",
    "            print fr.data,\n",
    "    \n",
    "rear = None\n",
    "front = None\n",
    "l = linkList()\n",
    "while(1):\n",
    "    print \"\\n1.PUSH\"\n",
    "    print \"2.POP\"\n",
    "    print \"3.TRAVERSE\"\n",
    "    print \"4.EXIT\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        rear = l.push(rear)\n",
    "        if front == None:\n",
    "            front = rear\n",
    "    elif choice == 2:\n",
    "        front = l.pop(front, rear)\n",
    "        if front == None:\n",
    "            rear = None\n",
    "    elif choice == 3:\n",
    "        l.traverse(front, rear)\n",
    "    elif choice == 4:\n",
    "        sys.exit()    \n",
    "    else:\n",
    "        print \"Wrong choice\"\n",
    "        print \"\\nDo you want to continue (Y/y) = \"\n",
    "        ch = raw_input()\n",
    "        if ch == 'Y' or ch == 'y':\n",
    "            continue\n",
    "        else:\n",
    "            sys.exit()\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 8, page no. 127"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "\n",
      "Polynomial 1 : \n",
      "How many terms u want to enter: \n",
      "2\n",
      "Enter coeficient for term 0:\n",
      "2\n",
      "Enter exponent for term 0:\n",
      "3\n",
      "Enter coeficient for term 1:\n",
      "4\n",
      "Enter exponent for term 1:\n",
      "5\n",
      "\n",
      "Polynomial 2 :\n",
      "How many terms u want to enter: \n",
      "2\n",
      "Enter coeficient for term 0:\n",
      "1\n",
      "Enter exponent for term 0:\n",
      "2\n",
      "Enter coeficient for term 1:\n",
      "3\n",
      "Enter exponent for term 1:\n",
      "4\n",
      "\n",
      "Polynomial 1 is: \n",
      "(4.0x^5) + \n",
      "(2.0x^3) + \n",
      "\b\b \n",
      "\n",
      "Polynomial 2 is: \n",
      "(3.0x^4) + \n",
      "(1.0x^2) + \n",
      "\b\b \n",
      "\n",
      "\n",
      "Added polynomial is: \n",
      "(1.0x^2) + \n",
      "\b\b \n",
      "\n"
     ]
    }
   ],
   "source": [
    "class node:\n",
    "    \n",
    "    def __init__(self):\n",
    "        self.coef = 0.0\n",
    "        self.expo = 0\n",
    "        self.link = None\n",
    "\n",
    "def insert(start, co, ex):\n",
    "    ptr = node()\n",
    "    tmp = node()\n",
    "    tmp.coef = co\n",
    "    tmp.expo = ex\n",
    "    if(start==None or ex>start.expo):\n",
    "        tmp.link=start\n",
    "        start = tmp\n",
    "    else:\n",
    "        ptr=start\n",
    "        while(ptr.link != None and ptr.link.expo > ex):\n",
    "            ptr = ptr.link\n",
    "            tmp.link = ptr.link\n",
    "            ptr.link = tmp\n",
    "            if(ptr.link==None):\n",
    "                tmp.link = None\n",
    "    return start\n",
    "\n",
    "def poly_add(p1, p2):\n",
    "    p3 = node()\n",
    "    tmp = node()\n",
    "    p3_start = None\n",
    "    if(p1 == None and p2 == None):\n",
    "        return p3_start\n",
    "    while(p1 != None and p2 != None):\n",
    "        if(p3_start == None):\n",
    "            p3_start = tmp\n",
    "            p3 = p3_start\n",
    "        else:\n",
    "            p3.link = tmp\n",
    "            p3 = p3.link\n",
    "        if(p1.expo > p2.expo):\n",
    "            tmp.coef=p1.coef\n",
    "            tmp.expo=p1.expo\n",
    "            p1 = p1.link\n",
    "        else:\n",
    "            if(p2.expo > p1.expo):\n",
    "                tmp.coef = p2.coef\n",
    "                tmp.expo = p2.expo\n",
    "                p2 = p2.link\n",
    "            else:\n",
    "                if(p1.expo == p2.expo):\n",
    "                    tmp.coef=p1.coef + p2.coef\n",
    "                    tmp.expo=p1.expo\n",
    "                    p1=p1.link\n",
    "                    p2=p2.link\n",
    "    while(p1!=None):\n",
    "        tmp.coef = p1.coef\n",
    "        tmp.expo = p1.expo\n",
    "        if (p3_start==None):\n",
    "            p3_start=tmp\n",
    "            p3=p3_start\n",
    "        else:\n",
    "            p3.link=tmp\n",
    "            p3=p3.link\n",
    "        p1=p1.link\n",
    "    while(p2!=None):\n",
    "        tmp.coef = p2.coef\n",
    "        tmp.expo = p2.expo\n",
    "        if (p3_start==None):\n",
    "            p3_start = tmp\n",
    "            p3 = p3_start\n",
    "        else:\n",
    "            p3.link = tmp\n",
    "            p3 = p3.link\n",
    "        p2 = p2.link\n",
    "    p3.link = None\n",
    "    return p3_start\n",
    "\n",
    "def enter(start):\n",
    "    print \"How many terms u want to enter: \"\n",
    "    n = int(raw_input())\n",
    "    for i in range(n):\n",
    "        print \"Enter coeficient for term %d:\" %i\n",
    "        co = float(raw_input())\n",
    "        print \"Enter exponent for term %d:\" %i\n",
    "        ex = int(raw_input())\n",
    "        start = insert(start,co,ex);\n",
    "    return start\n",
    "\n",
    "def display(ptr):\n",
    "    if (ptr==None):\n",
    "        print \"Empty...\"\n",
    "        return\n",
    "    while(ptr!=None):\n",
    "        print \"(%.1fx^%d) + \" %(ptr.coef, ptr.expo)\n",
    "        ptr = ptr.link\n",
    "    print \"\\b\\b \\n\"\n",
    "\n",
    "p1_start=None\n",
    "p2_start=None\n",
    "p3_start=None\n",
    "print \"\\nPolynomial 1 : \"\n",
    "p1_start = enter(p1_start)\n",
    "print \"\\nPolynomial 2 :\"\n",
    "p2_start = enter(p2_start)\n",
    "p3_start = poly_add(p1_start, p2_start)\n",
    "print \"\\nPolynomial 1 is: \"\n",
    "display(p1_start)\n",
    "print \"Polynomial 2 is: \"\n",
    "display(p2_start)\n",
    "print \"\\nAdded polynomial is: \"\n",
    "display (p3_start)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 9, page no. 134"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.exit\n",
      "Enter your choice: 1\n",
      " \n",
      "How many nodes you want: 3\n",
      " Enter the element: 5\n",
      " Enter the element: 10\n",
      " Enter the element: 15\n",
      " \n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.exit\n",
      "Enter your choice: 5\n",
      " \n",
      "List is :\n",
      "\n",
      "15 \n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Count\n",
      "7.Reverse\n",
      "8.exit\n",
      "Enter your choice: 8\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, info=0, next=None, prev=None):\n",
    "        self.info = info\n",
    "        self.next = next\n",
    "        self.prev = prev\n",
    "\n",
    "start = node()\n",
    "\n",
    "def create_list(num):\n",
    "    global start\n",
    "    tmp = node()\n",
    "    tmp.info = num\n",
    "    q = node()\n",
    "    if(start.next == None):\n",
    "        tmp.prev = None\n",
    "        start.prev = tmp\n",
    "        start = tmp\n",
    "    else:\n",
    "        q = start\n",
    "    while(q.next != None):\n",
    "        q = q.next\n",
    "        q.next = tmp\n",
    "        tmp.prev = q\n",
    "\n",
    "def addatbeg(num):\n",
    "    global start\n",
    "    tmp = node()\n",
    "    tmp.info = num\n",
    "    tmp.next = start\n",
    "    start.prev = tmp\n",
    "    start = tmp\n",
    "\n",
    "def addafter(num, pos):\n",
    "    global start\n",
    "    q=start\n",
    "    for i in range(0,pos-1):\n",
    "        q=q.next\n",
    "        if(q==None):\n",
    "            print \"\\nThere are less than %d elements\\n\" %pos\n",
    "            return\n",
    "    tmp = node()\n",
    "    tmp.info = num\n",
    "    q.next.prev = tmp\n",
    "    tmp.next = q.next\n",
    "    tmp.prev = q\n",
    "    q.next = tmp\n",
    "\n",
    "def my_del(num):\n",
    "    global start\n",
    "    if(start.info==num):\n",
    "        tmp = start\n",
    "        start = start.next\n",
    "        start.prev = None\n",
    "        return\n",
    "    q = start;\n",
    "    while(q.next.next != None):\n",
    "        if(q.next.info==num):\n",
    "            tmp=q.next\n",
    "            q.next=tmp.next\n",
    "            tmp.next.prev = q\n",
    "            return\n",
    "    q = q.next\n",
    "    if (q.next.info==num):\n",
    "        tmp = q.next\n",
    "        q.next = None\n",
    "        return\n",
    "    print \"\\nElement %d not found\\n\" %num\n",
    "\n",
    "def display():\n",
    "    global start\n",
    "    if(start==None):\n",
    "        print \"\\nList is empty\\n\"\n",
    "        return\n",
    "    q = start\n",
    "    print \"\\nList is :\\n\"\n",
    "    while(q!=None):\n",
    "        print q.info,\n",
    "        q = q.next\n",
    "\n",
    "def count():\n",
    "    global start\n",
    "    q=start\n",
    "    cnt=0\n",
    "    while(q!=None):\n",
    "        q=q.next\n",
    "        cnt+=1\n",
    "    print \"\\nNumber of elements are \\n\", cnt\n",
    "\n",
    "def rev():\n",
    "    global start\n",
    "    p1=start\n",
    "    p2=p1.next\n",
    "    p1.next=None\n",
    "    p1.prev=p2\n",
    "    while(p2!=None):\n",
    "        p2.prev=p2.next\n",
    "        p2.next=p1\n",
    "        p1=p2\n",
    "        p2=p2.prev\n",
    "    start=p1\n",
    "\n",
    "while(1):\n",
    "    print \"\\n1.Create List\"\n",
    "    print \"2.Add at begining\"\n",
    "    print \"3.Add after\"\n",
    "    print \"4.Delete\"\n",
    "    print \"5.Display\"\n",
    "    print \"6.Count\"\n",
    "    print \"7.Reverse\"\n",
    "    print \"8.exit\"\n",
    "    print \"Enter your choice: \",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        print \"\\nHow many nodes you want: \",\n",
    "        n = int(raw_input())\n",
    "        for i in range(n):\n",
    "            print \"Enter the element: \",\n",
    "            m = int(raw_input())\n",
    "            create_list(m)\n",
    "    elif choice == 2:\n",
    "        print \"\\nEnter the element: \",\n",
    "        m = int(raw_input())\n",
    "        addatbeg(m)\n",
    "    elif choice == 3:\n",
    "        print \"\\nEnter the element: \",\n",
    "        m = int(raw_input())\n",
    "        print \"Enter the position after which this element is inserted: \",\n",
    "        po = int(raw_input())\n",
    "        addafter(m,po)\n",
    "    elif choice == 4:\n",
    "        print \"\\nEnter the element for deletion: \",\n",
    "        m = int(raw_input())\n",
    "        my_del(m);\n",
    "    elif choice == 5:\n",
    "        display()\n",
    "    elif choice == 6:\n",
    "        count()\n",
    "    elif choice == 7:\n",
    "        rev()\n",
    "    elif choice == 8:\n",
    "        sys.exit()\n",
    "    else:\n",
    "        print \"\\nWrong choice\\n\""
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 10, page no. 141"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " \n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Quit\n",
      "Enter your choice:\n",
      "1\n",
      "How many nodes you want:3\n",
      " \n",
      "Enter the element:5\n",
      " \n",
      "Enter the element:10\n",
      " \n",
      "Enter the element:15\n",
      " \n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Quit\n",
      "Enter your choice:\n",
      "5\n",
      "List is:\n",
      "5 10 15\n",
      "\n",
      "1.Create List\n",
      "2.Add at begining\n",
      "3.Add after\n",
      "4.Delete\n",
      "5.Display\n",
      "6.Quit\n",
      "Enter your choice:\n",
      "6\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, info=None, link=None):\n",
    "        self.info = info\n",
    "        self.link = link\n",
    "\n",
    "last = None\n",
    "class Circular_Linked:\n",
    "    def create_list(self, num):\n",
    "        global last\n",
    "        q = node()\n",
    "        tmp = node()\n",
    "        tmp.info = num\n",
    "        if (last == None):\n",
    "            last = tmp\n",
    "            tmp.link = last\n",
    "        else:\n",
    "            tmp.link = last.link\n",
    "            last.link = tmp\n",
    "            last = tmp\n",
    "\n",
    "    def addatbeg(self, num):\n",
    "        global last\n",
    "        tmp = node()\n",
    "        tmp.info = num\n",
    "        tmp.link = last.link\n",
    "        last.link = tmp\n",
    "\n",
    "    def addafter(self, num, pos):\n",
    "        global last\n",
    "        q = node()\n",
    "        tmp = node()\n",
    "        q = last.link\n",
    "        for i in range(0, pos-1):\n",
    "            q = q.link\n",
    "            if (q == last.link):\n",
    "                print \"There are less than \", pos, \" elements\"\n",
    "                return\n",
    "        tmp.link = q.link\n",
    "        tmp.info = num\n",
    "        q.link = tmp\n",
    "        if(q==last):\n",
    "            last=tmp\n",
    "\n",
    "    def my_del(self):\n",
    "        global last\n",
    "        if(last == None):\n",
    "            print \"List underflow\"\n",
    "            return\n",
    "        print \"Enter the number for deletion:\"\n",
    "        num = int(raw_input())\n",
    "        q = node()\n",
    "        tmp = node()\n",
    "        if( last.link == last and last.info == num):\n",
    "            tmp = last\n",
    "            last = None\n",
    "            return\n",
    "        q = last.link\n",
    "        if(q.info == num):\n",
    "            tmp = q\n",
    "            last.link = q.link\n",
    "            return\n",
    "        while(q.link != last):\n",
    "            if(q.link.info == num):\n",
    "                tmp = q.link\n",
    "                q.link = tmp.link\n",
    "                print num, \" deleted\"\n",
    "            q = q.link\n",
    "        if(q.link.info == num):\n",
    "            tmp = q.link\n",
    "            q.link = last.link\n",
    "            last = q\n",
    "            return\n",
    "        print \"Element \",num,\" not found\"\n",
    "\n",
    "    def display(self):\n",
    "        global last\n",
    "        q = node()\n",
    "        if(last == None):\n",
    "            print \"List is empty\"\n",
    "            return\n",
    "        q = last.link\n",
    "        print \"List is:\"\n",
    "        while(q != last):\n",
    "            print q.info,\n",
    "            q = q.link\n",
    "        print last.info\n",
    "        \n",
    "co = Circular_Linked()\n",
    "while(1):\n",
    "    print \"\\n1.Create List\"\n",
    "    print \"2.Add at begining\"\n",
    "    print \"3.Add after\"\n",
    "    print \"4.Delete\"\n",
    "    print \"5.Display\"\n",
    "    print \"6.Quit\"\n",
    "    print \"Enter your choice:\"\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        print \"How many nodes you want:\",\n",
    "        n = int(raw_input())\n",
    "        for i in range(n):\n",
    "            print \"\\nEnter the element:\",\n",
    "            m = int(raw_input())\n",
    "            co.create_list(m)\n",
    "    elif choice == 2:\n",
    "        print \"\\nEnter the element:\",\n",
    "        m = int(raw_input())\n",
    "        co.addatbeg(m)\n",
    "    elif choice == 3:\n",
    "        print \"\\nEnter the element:\",\n",
    "        m = int(raw_input())\n",
    "        print \"\\nEnter the position after which this element is inserted:\",\n",
    "        po = int(raw_input())\n",
    "        co.addafter(m,po)\n",
    "    elif choice == 4:\n",
    "        co.my_del()\n",
    "    elif choice == 5:\n",
    "        co.display()\n",
    "    elif choice == 6:\n",
    "        sys.exit()\n",
    "    else:\n",
    "        print \"Wrong choice\""
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Example 11, page no. 148"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "\n",
      "1.Insert\n",
      "2.Delete\n",
      "3.Display\n",
      "4.Quit\n",
      "Enter your choice4\n"
     ]
    },
    {
     "ename": "SystemExit",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "An exception has occurred, use %tb to see the full traceback.\n",
      "\u001b[1;31mSystemExit\u001b[0m\n"
     ]
    },
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "To exit: use 'exit', 'quit', or Ctrl-D.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "\n",
    "class node:\n",
    "    def __init__(self, priority=None, info=None, link=None):\n",
    "        self.priority = priority\n",
    "        self.info = info\n",
    "        self.link = link\n",
    "\n",
    "def insert(front):\n",
    "    tmp = node()\n",
    "    q = node()\n",
    "    print \"Input the item value to be added in the queue:\"\n",
    "    added_item = int(raw_input())\n",
    "    print \"Enter its priority:\"\n",
    "    item_priority = int(raw_input())\n",
    "    tmp.info = added_item\n",
    "    tmp.priority = item_priority\n",
    "    if(front == None or item_priority < front.priority):\n",
    "        tmp.link = front\n",
    "        front = tmp\n",
    "    else:\n",
    "        q = front\n",
    "        while(q.link != None and q.link.priority <= item_priority):\n",
    "            q = q.link\n",
    "            tmp.link = q.link\n",
    "            q.link = tmp\n",
    "    return front\n",
    "\n",
    "def my_del(front):\n",
    "    tmp = node()\n",
    "    if(front == None):\n",
    "        print \"Queue Underflow\"\n",
    "    else:\n",
    "        tmp = front;\n",
    "        print \"Deleted item is \", tmp.info\n",
    "        front = front.link\n",
    "    return front\n",
    "\n",
    "def display(front):\n",
    "    ptr = node()\n",
    "    ptr = front;\n",
    "    if(front == None):\n",
    "        print \"Queue is empty\"\n",
    "    else:\n",
    "        print \"Queue is: \"\n",
    "        print \"Priority Item \"\n",
    "        while(ptr != None):\n",
    "            print \"%5d %5d \" %(ptr.priority,ptr.info)\n",
    "            ptr = ptr.link\n",
    "\n",
    "front = None\n",
    "while(1):\n",
    "    print \"\\n1.Insert\"\n",
    "    print \"2.Delete\"\n",
    "    print \"3.Display\"\n",
    "    print \"4.Quit\"\n",
    "    print \"Enter your choice\",\n",
    "    choice = int(raw_input())\n",
    "    if choice == 1:\n",
    "        front = insert(front);\n",
    "    elif choice == 2:\n",
    "        front = my_del(front);\n",
    "    elif choice == 3:\n",
    "        display(front)\n",
    "    elif choice == 4:\n",
    "        sys.exit()\n",
    "    else:\n",
    "        print \"Wrong choice\""
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 2",
   "language": "python",
   "name": "python2"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 2
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython2",
   "version": "2.7.6"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 0
}
